<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/clap-3.2.16/src/lib.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>lib.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../clap/index.html"><div class="logo-container"><img src="https://raw.githubusercontent.com/clap-rs/clap/master/assets/clap.png" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../clap/index.html"><div class="logo-container">
                    <img src="https://raw.githubusercontent.com/clap-rs/clap/master/assets/clap.png" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../clap/index.html">
                        <img src="https://raw.githubusercontent.com/clap-rs/clap/master/assets/clap.png" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
<span id="220">220</span>
<span id="221">221</span>
<span id="222">222</span>
<span id="223">223</span>
<span id="224">224</span>
<span id="225">225</span>
<span id="226">226</span>
<span id="227">227</span>
<span id="228">228</span>
<span id="229">229</span>
<span id="230">230</span>
<span id="231">231</span>
<span id="232">232</span>
</pre><pre class="rust"><code><span class="comment">// Copyright ⓒ 2015-2016 Kevin B. Knapp and [`clap-rs` contributors](https://github.com/clap-rs/clap/graphs/contributors).</span>
<span class="comment">// Licensed under the MIT license</span>
<span class="comment">// (see LICENSE or &lt;http://opensource.org/licenses/MIT&gt;) All files in the project carrying such</span>
<span class="comment">// notice may not be copied, modified, or distributed except according to those terms.</span>

<span class="doccomment">//! &gt; **Command Line Argument Parser for Rust**</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! Quick Links:</span>
<span class="doccomment">//! - Derive [tutorial][_derive::_tutorial] and [reference][_derive]</span>
<span class="doccomment">//! - Builder [tutorial][_tutorial] and [reference](index.html)</span>
<span class="doccomment">//! - [Cookbook][_cookbook]</span>
<span class="doccomment">//! - [FAQ][_faq]</span>
<span class="doccomment">//! - [Discussions](https://github.com/clap-rs/clap/discussions)</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ## Aspirations</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! - Out of the box, users get a polished CLI experience</span>
<span class="doccomment">//!   - Including common argument behavior, help generation, suggested fixes for users, colored output, [shell completions](https://github.com/clap-rs/clap/tree/master/clap_complete), etc</span>
<span class="doccomment">//! - Flexible enough to port your existing CLI interface</span>
<span class="doccomment">//!   - However, we won&#39;t necessarily streamline support for each use case</span>
<span class="doccomment">//! - Reasonable parse performance</span>
<span class="doccomment">//! - Resilient maintainership, including</span>
<span class="doccomment">//!   - Willing to break compatibility rather than batching up breaking changes in large releases</span>
<span class="doccomment">//!   - Leverage feature flags to keep to one active branch</span>
<span class="doccomment">//!   - Being under [WG-CLI](https://github.com/rust-cli/team/) to increase the bus factor</span>
<span class="doccomment">//! - We follow semver and will wait about 6-9 months between major breaking changes</span>
<span class="doccomment">//! - We will support the last two minor Rust releases (MSRV, currently 1.56.1)</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! While these aspirations can be at odds with fast build times and low binary</span>
<span class="doccomment">//! size, we will still strive to keep these reasonable for the flexibility you</span>
<span class="doccomment">//! get.  Check out the</span>
<span class="doccomment">//! [argparse-benchmarks](https://github.com/rust-cli/argparse-benchmarks-rs) for</span>
<span class="doccomment">//! CLI parsers optimized for other use cases.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ## Example</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! Run</span>
<span class="doccomment">//! ```console</span>
<span class="doccomment">//! $ cargo add clap --features derive</span>
<span class="doccomment">//! ```</span>
<span class="doccomment">//! *(See also [feature flag reference][_features])*</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! Then define your CLI in `main.rs`:</span>
<span class="attribute">#![<span class="ident">cfg_attr</span>(<span class="ident">not</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;derive&quot;</span>), <span class="ident">doc</span> <span class="op">=</span> <span class="string">&quot; ```ignore&quot;</span>)]</span>
<span class="attribute">#![<span class="ident">cfg_attr</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;derive&quot;</span>, <span class="ident">doc</span> <span class="op">=</span> <span class="string">&quot; ```no_run&quot;</span>)]</span>
<span class="attribute">#![<span class="ident">doc</span> <span class="op">=</span> <span class="macro">include_str!</span>(<span class="string">&quot;../examples/demo.rs&quot;</span>)]</span>
<span class="doccomment">//! ```</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! And try it out:</span>
<span class="attribute">#![<span class="ident">doc</span> <span class="op">=</span> <span class="macro">include_str!</span>(<span class="string">&quot;../examples/demo.md&quot;</span>)]</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! See also the derive [tutorial][_derive::_tutorial] and [reference][_derive]</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ### Related Projects</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! Augment clap:</span>
<span class="doccomment">//! - [wild](https://crates.io/crates/wild) for supporting wildcards (`*`) on Windows like you do Linux</span>
<span class="doccomment">//! - [argfile](https://crates.io/crates/argfile) for loading additional arguments from a file (aka response files)</span>
<span class="doccomment">//! - [shadow-rs](https://crates.io/crates/shadow-rs) for generating `Command::long_version`</span>
<span class="doccomment">//! - [clap_mangen](https://crates.io/crates/clap_mangen) for generating man page source (roff)</span>
<span class="doccomment">//! - [clap_complete](https://crates.io/crates/clap_complete) for shell completion support</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! CLI Helpers</span>
<span class="doccomment">//! - [clap-verbosity-flag](https://crates.io/crates/clap-verbosity-flag)</span>
<span class="doccomment">//! - [clap-cargo](https://crates.io/crates/clap-cargo)</span>
<span class="doccomment">//! - [concolor-clap](https://crates.io/crates/concolor-clap)</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! Testing</span>
<span class="doccomment">//! - [`trycmd`](https://crates.io/crates/trycmd):  Bulk snapshot testing</span>
<span class="doccomment">//! - [`snapbox`](https://crates.io/crates/snapbox):  Specialized snapshot testing</span>
<span class="doccomment">//! - [`assert_cmd`](https://crates.io/crates/assert_cmd) and [`assert_fs`](https://crates.io/crates/assert_fs): Customized testing</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! Documentation:</span>
<span class="doccomment">//! - [Command-line Apps for Rust](https://rust-cli.github.io/book/index.html) book</span>
<span class="doccomment">//!</span>

<span class="attribute">#![<span class="ident">cfg_attr</span>(<span class="ident">docsrs</span>, <span class="ident">feature</span>(<span class="ident">doc_auto_cfg</span>))]</span>
<span class="attribute">#![<span class="ident">doc</span>(<span class="ident">html_logo_url</span> <span class="op">=</span> <span class="string">&quot;https://raw.githubusercontent.com/clap-rs/clap/master/assets/clap.png&quot;</span>)]</span>
<span class="attribute">#![<span class="ident">warn</span>(
    <span class="ident">missing_docs</span>,
    <span class="ident">missing_debug_implementations</span>,
    <span class="ident">missing_copy_implementations</span>,
    <span class="ident">trivial_casts</span>,
    <span class="ident">unused_allocation</span>,
    <span class="ident">trivial_numeric_casts</span>,
    <span class="ident">clippy::single_char_pattern</span>
)]</span>
<span class="attribute">#![<span class="ident">forbid</span>(<span class="ident">unsafe_code</span>)]</span>
<span class="comment">// HACK https://github.com/rust-lang/rust-clippy/issues/7290</span>
<span class="attribute">#![<span class="ident">allow</span>(<span class="ident">clippy::single_component_path_imports</span>)]</span>
<span class="attribute">#![<span class="ident">allow</span>(<span class="ident">clippy::branches_sharing_code</span>)]</span>
<span class="comment">// Doesn&#39;t allow for debug statements, etc to be unique</span>
<span class="attribute">#![<span class="ident">allow</span>(<span class="ident">clippy::if_same_then_else</span>)]</span>

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">not</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>))]</span>
<span class="macro">compile_error!</span>(<span class="string">&quot;`std` feature is currently required to build `clap`&quot;</span>);

<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::builder::ArgAction</span>;
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::builder::Command</span>;
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::builder</span>::{<span class="ident">Arg</span>, <span class="ident">ArgGroup</span>};
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::error::Error</span>;
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::parser::ArgMatches</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;color&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::util::color::ColorChoice</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">not</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;color&quot;</span>))]</span>
<span class="attribute">#[<span class="ident">allow</span>(<span class="ident">unused_imports</span>)]</span>
<span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::util::color::ColorChoice</span>;

<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::derive</span>::{<span class="ident">Args</span>, <span class="ident">CommandFactory</span>, <span class="ident">FromArgMatches</span>, <span class="ident">Parser</span>, <span class="ident">Subcommand</span>, <span class="ident">ValueEnum</span>};

<span class="attribute">#[<span class="ident">allow</span>(<span class="ident">deprecated</span>)]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::builder::App</span>;
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::builder</span>::{<span class="ident">AppFlags</span>, <span class="ident">AppSettings</span>, <span class="ident">ArgFlags</span>, <span class="ident">ArgSettings</span>, <span class="ident">PossibleValue</span>, <span class="ident">ValueHint</span>};
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::error</span>::{<span class="ident">ErrorKind</span>, <span class="prelude-ty">Result</span>};
<span class="attribute">#[<span class="ident">allow</span>(<span class="ident">deprecated</span>)]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::parser</span>::{<span class="ident">Indices</span>, <span class="ident">OsValues</span>, <span class="ident">ValueSource</span>, <span class="ident">Values</span>};

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;yaml&quot;</span>)]</span>
<span class="attribute">#[<span class="ident">doc</span>(<span class="ident">hidden</span>)]</span>
<span class="attribute">#[<span class="ident">cfg_attr</span>(
    <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;deprecated&quot;</span>,
    <span class="ident">deprecated</span>(
        <span class="ident">since</span> <span class="op">=</span> <span class="string">&quot;3.0.0&quot;</span>,
        <span class="ident">note</span> <span class="op">=</span> <span class="string">&quot;Deprecated in Issue #3087, maybe clap::Parser would fit your use case?&quot;</span>
    )
)]</span>
<span class="attribute">#[<span class="ident">doc</span>(<span class="ident">hidden</span>)]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">yaml_rust::YamlLoader</span>;

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;derive&quot;</span>)]</span>
<span class="attribute">#[<span class="ident">doc</span>(<span class="ident">hidden</span>)]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">clap_derive</span>::{<span class="self">self</span>, <span class="kw-2">*</span>};

<span class="doccomment">/// Deprecated, replaced with [`CommandFactory`]</span>
<span class="attribute">#[<span class="ident">cfg_attr</span>(
    <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;deprecated&quot;</span>,
    <span class="ident">deprecated</span>(<span class="ident">since</span> <span class="op">=</span> <span class="string">&quot;3.0.0&quot;</span>, <span class="ident">note</span> <span class="op">=</span> <span class="string">&quot;Replaced with `CommandFactory`&quot;</span>)
)]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">CommandFactory</span> <span class="kw">as</span> <span class="ident">IntoApp</span>;
<span class="doccomment">/// Deprecated, replaced with [`Parser`]</span>
<span class="attribute">#[<span class="ident">cfg_attr</span>(
    <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;deprecated&quot;</span>,
    <span class="ident">deprecated</span>(<span class="ident">since</span> <span class="op">=</span> <span class="string">&quot;3.0.0&quot;</span>, <span class="ident">note</span> <span class="op">=</span> <span class="string">&quot;Replaced with `Parser`&quot;</span>)
)]</span>
<span class="attribute">#[<span class="ident">doc</span>(<span class="ident">hidden</span>)]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">Parser</span> <span class="kw">as</span> <span class="ident">StructOpt</span>;
<span class="doccomment">/// Deprecated, replaced with [`ValueEnum`]</span>
<span class="attribute">#[<span class="ident">cfg_attr</span>(
    <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;deprecated&quot;</span>,
    <span class="ident">deprecated</span>(<span class="ident">since</span> <span class="op">=</span> <span class="string">&quot;3.2.0&quot;</span>, <span class="ident">note</span> <span class="op">=</span> <span class="string">&quot;Replaced with `ValueEnum`&quot;</span>)
)]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">ValueEnum</span> <span class="kw">as</span> <span class="ident">ArgEnum</span>;

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;unstable-doc&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">_cookbook</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;unstable-doc&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">_derive</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;unstable-doc&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">_faq</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;unstable-doc&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">_features</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;unstable-doc&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">_tutorial</span>;

<span class="attribute">#[<span class="ident">doc</span>(<span class="ident">hidden</span>)]</span>
<span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">__macro_refs</span> {
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">any</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;derive&quot;</span>, <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;cargo&quot;</span>))]</span>
    <span class="attribute">#[<span class="ident">doc</span>(<span class="ident">hidden</span>)]</span>
    <span class="kw">pub</span> <span class="kw">use</span> <span class="ident">once_cell</span>;
}

<span class="attribute">#[<span class="ident">macro_use</span>]</span>
<span class="attribute">#[<span class="ident">allow</span>(<span class="ident">missing_docs</span>)]</span>
<span class="kw">mod</span> <span class="ident">macros</span>;

<span class="kw">mod</span> <span class="ident">derive</span>;

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;regex&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::builder::RegexRef</span>;

<span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">builder</span>;
<span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">error</span>;
<span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">parser</span>;

<span class="kw">mod</span> <span class="ident">mkeymap</span>;
<span class="kw">mod</span> <span class="ident">output</span>;
<span class="kw">mod</span> <span class="ident">util</span>;

<span class="kw">const</span> <span class="ident">INTERNAL_ERROR_MSG</span>: <span class="kw-2">&amp;</span><span class="ident">str</span> <span class="op">=</span> <span class="string">&quot;Fatal internal error. Please consider filing a bug \
                                  report at https://github.com/clap-rs/clap/issues&quot;</span>;
<span class="kw">const</span> <span class="ident">INVALID_UTF8</span>: <span class="kw-2">&amp;</span><span class="ident">str</span> <span class="op">=</span> <span class="string">&quot;unexpected invalid UTF-8 code point&quot;</span>;

<span class="doccomment">/// Deprecated, replaced with [`Command::new`], unless you were looking for [Subcommand]</span>
<span class="attribute">#[<span class="ident">cfg_attr</span>(
    <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;deprecated&quot;</span>,
    <span class="ident">deprecated</span>(
        <span class="ident">since</span> <span class="op">=</span> <span class="string">&quot;3.0.0&quot;</span>,
        <span class="ident">note</span> <span class="op">=</span> <span class="string">&quot;Replaced with `Command::new` unless you intended the `Subcommand` trait&quot;</span>
    )
)]</span>
<span class="attribute">#[<span class="ident">doc</span>(<span class="ident">hidden</span>)]</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Copy</span>, <span class="ident">Clone</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">SubCommand</span> {}

<span class="attribute">#[<span class="ident">allow</span>(<span class="ident">deprecated</span>)]</span>
<span class="kw">impl</span> <span class="ident">SubCommand</span> {
    <span class="doccomment">/// Deprecated, replaced with [`Command::new`].</span>
    <span class="doccomment">/// Did you mean Subcommand (lower-case c)?</span>
    <span class="attribute">#[<span class="ident">cfg_attr</span>(
        <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;deprecated&quot;</span>,
        <span class="ident">deprecated</span>(<span class="ident">since</span> <span class="op">=</span> <span class="string">&quot;3.0.0&quot;</span>, <span class="ident">note</span> <span class="op">=</span> <span class="string">&quot;Replaced with `Command::new`&quot;</span>)
    )]</span>
    <span class="attribute">#[<span class="ident">doc</span>(<span class="ident">hidden</span>)]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">with_name</span><span class="op">&lt;</span><span class="lifetime">&#39;help</span><span class="op">&gt;</span>(<span class="ident">name</span>: <span class="kw-2">&amp;</span><span class="ident">str</span>) -&gt; <span class="ident">App</span><span class="op">&lt;</span><span class="lifetime">&#39;help</span><span class="op">&gt;</span> {
        <span class="ident">Command::new</span>(<span class="ident">name</span>)
    }

    <span class="doccomment">/// Deprecated in [Issue #3087](https://github.com/clap-rs/clap/issues/3087), maybe [`clap::Parser`][crate::Parser] would fit your use case?</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;yaml&quot;</span>)]</span>
    <span class="attribute">#[<span class="ident">cfg_attr</span>(
        <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;deprecated&quot;</span>,
        <span class="ident">deprecated</span>(
            <span class="ident">since</span> <span class="op">=</span> <span class="string">&quot;3.0.0&quot;</span>,
            <span class="ident">note</span> <span class="op">=</span> <span class="string">&quot;Deprecated in Issue #3087, maybe clap::Parser would fit your use case?&quot;</span>
        )
    )]</span>
    <span class="attribute">#[<span class="ident">doc</span>(<span class="ident">hidden</span>)]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">from_yaml</span>(<span class="ident">yaml</span>: <span class="kw-2">&amp;</span><span class="ident">yaml_rust::Yaml</span>) -&gt; <span class="ident">App</span> {
        <span class="attribute">#![<span class="ident">allow</span>(<span class="ident">deprecated</span>)]</span>
        <span class="ident">Command::from_yaml</span>(<span class="ident">yaml</span>)
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="clap" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>